// $ANTLR 3.2 Sep 23, 2009 14:05:07 org/deri/xsparql/rewriter/XSPARQLSimplifier.g 2012-07-26 14:56:50

  package org.deri.xsparql.rewriter;

  import java.util.logging.Logger;
  import java.util.Collection;
  import java.util.ArrayList;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

/**
 *
 * Copyright (C) 2011, NUI Galway.
 * All rights reserved.
 *
 * The software in this package is published under the terms of the BSD style license a copy of which has been included
 * with this distribution in the bsb_license.txt file and/or available on NUI Galway Server at
 * http://xsparql.deri.ie/license/bsd_license.txt
 *
 * Created: 09 February 2011, Reasoning and Querying Unit (URQ), Digital Enterprise Research Institute (DERI) on behalf of
 * NUI Galway.
 */
public class XSPARQLSimplifier extends AbstractMyTreeRewriter {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VAR", "ENDELM", "INTEGER", "LCURLY", "RCURLY", "NCNAME", "QSTRING", "DOT", "AT", "ASSIGN", "CARET", "CARETCARET", "COLON", "COMMA", "SLASH", "LBRACKET", "RBRACKET", "LPAR", "RPAR", "SEMICOLON", "STAR", "DOTDOT", "SLASHSLASH", "LESSTHAN", "GREATERTHAN", "PLUS", "MINUS", "UNIONSYMBOL", "QUESTIONMARK", "LESSTHANLESSTHAN", "GREATERTHANEQUALS", "LESSTHANEQUALS", "HAFENEQUALS", "EQUALS", "COLONCOLON", "BLANK_NODE_LABEL", "BNODE_CONSTRUCT", "IRI_CONSTRUCT", "ASK", "DESCRIBE", "SELECT", "PNAME_NS", "PNAME_LN", "CDATASTART", "CDATAELMEND", "RCURLYGREATERTHAN", "LESSTHANLCURLY", "ORSYMBOL", "ANDSYMBOL", "NOT", "WHITESPACE", "IRIREF", "NCNAMEELM", "ENDTAG", "A", "IS", "EQ", "NE", "LT", "GE", "LE", "GT", "FOR", "FROM", "LIMIT", "OFFSET", "LET", "ORDER", "BY", "ATS", "IN", "AS", "DESCENDING", "ASCENDING", "STABLE", "IF", "THEN", "ELSE", "RETURN", "CONSTRUCT", "WHERE", "GREATEST", "LEAST", "COLLATION", "CHILD", "DESCENDANT", "ATTRIBUTE", "SELF", "DESCENDANTORSELF", "FOLLOWINGSIBLING", "FOLLOWING", "PARENT", "ANCESTOR", "PRECEDINGSIBLING", "PRECEDING", "ANCESTORORSELF", "ORDERED", "UNORDERED", "DECLARE", "NAMESPACE", "DEFAULT", "ELEMENT", "FUNCTION", "BASEURI", "PREFIX", "BASE", "AND", "OR", "TO", "DIV", "IDIV", "MOD", "UNION", "INTERSECT", "EXCEPT", "INSTANCE", "TREAT", "CASTABLE", "CAST", "OF", "EMPTYSEQUENCE", "ITEM", "NODE", "DOCUMENTNODE", "TEXT", "COMMENT", "PROCESSINGINSTRUCTION", "SCHEMAATTRIBUTE", "SCHEMAELEMENT", "DOCUMENT", "NAMED", "OPTIONAL", "FILTER", "STR", "LANG", "LANGMATCHES", "DATATYPE", "BOUND", "ISIRI", "ISURI", "ISBLANK", "ISLITERAL", "REGEX", "TRUE", "FALSE", "GRAPH", "GREATERTHANGREATERTHAN", "DISTINCT", "GROUP", "HAVING", "ENDPOINT", "ROW", "T_NAMESPACE", "T_XML_ELEMENT", "T_XML_CONTENT", "T_XML_ATTRIBUTE", "T_FLWOR", "T_FUNCTION_DECL", "T_PARAMS", "T_FORLET", "T_WHERE", "T_SPARQL_FOR", "T_SPARQL_WHERE", "T_FOR", "T_LET", "T_CONSTRUCT", "T_ORDER", "T_RETURN", "T_UNION", "T_SQL_FOR", "T_SQL_WHERE", "T_SQL_FROM", "T_VAR", "T_TABLE", "T_BLANK", "T_ANON_BLANK", "T_EMPTY_ANON_BLANK", "T_SUBJECT", "T_VERB", "T_OBJECT", "T_MAIN", "T_PAR", "T_INSTANCEOF", "T_TYPE", "T_CASTAS", "T_CASTABLEAS", "T_TREATAS", "T_VARIABLE_DECL", "T_EXTERNAL_VARIABLE_DECL", "T_OPTION_DECL", "T_FUNCTION_CALL", "T_PARAM", "T_ORDER_BY", "T_STABLE_ORDER_BY", "T_GROUP_BY", "T_HAVING", "BOUNDARYSPACE", "STRIP", "VARIABLE", "IMPORT", "EXTERNAL", "NOPRESERVE", "PRESERVE", "CONSTRUCTION", "MODULE", "INHERIT", "NOINHERIT", "SCHEMA", "EMPTY", "ORDERING", "COPYNAMESPACES", "XQUERY", "VERSION", "ENCODING", "OPTION", "LAX", "CASE", "EVERY", "TYPESWITCH", "SATISFIES", "VALIDATE", "SOME", "STRICT", "ASC", "DESC", "T_MODULE_DECL", "T_VERSION", "T_BOUNDARYSPACE_DECL", "T_DEFAULT_DECL", "T_ORDER_DECL", "T_EMPTY_ORDER_DECL", "T_DEFAULT_COLLATION_DECL", "T_BASEURI_DECL", "T_MODULE_IMPORT", "T_SCHEMA_IMPORT", "T_QUERY_BODY", "T_BODY_PART", "XPATH", "T_LITERAL_CONSTRUCT", "T_IRI_CONSTRUCT", "T_EPILOGUE", "DECIMAL", "REWRITEVNODE", "REWRITEVNODE1", "DELETEVNODE", "T_QSTRING", "NOTHING", "T_XML_CONTENTS", "T_UNOPTIMIZED_FUNCTION_CALL"
    };
    public static final int FUNCTION=106;
    public static final int ENDTAG=57;
    public static final int STAR=24;
    public static final int ROW=155;
    public static final int T_MODULE_DECL=229;
    public static final int GRAPH=149;
    public static final int MOD=115;
    public static final int T_BLANK=178;
    public static final int BNODE_CONSTRUCT=40;
    public static final int T_INSTANCEOF=186;
    public static final int PNAME_LN=46;
    public static final int REGEX=146;
    public static final int CONSTRUCT=83;
    public static final int T_FOR=167;
    public static final int T_RETURN=171;
    public static final int T_ORDER_BY=196;
    public static final int NOT=53;
    public static final int T_EPILOGUE=244;
    public static final int EXCEPT=118;
    public static final int EOF=-1;
    public static final int T_ORDER_DECL=233;
    public static final int T_XML_CONTENT=158;
    public static final int LBRACKET=19;
    public static final int T_OBJECT=183;
    public static final int ISLITERAL=145;
    public static final int IMPORT=203;
    public static final int IRIREF=55;
    public static final int GREATERTHANEQUALS=34;
    public static final int PRECEDING=98;
    public static final int RETURN=82;
    public static final int ELEMENT=105;
    public static final int COPYNAMESPACES=214;
    public static final int T_PARAMS=162;
    public static final int EQ=60;
    public static final int BOUND=141;
    public static final int GREATERTHANGREATERTHAN=150;
    public static final int CHILD=88;
    public static final int GE=63;
    public static final int A=58;
    public static final int STRICT=226;
    public static final int T_FUNCTION_DECL=161;
    public static final int ASC=227;
    public static final int PRESERVE=206;
    public static final int LESSTHANEQUALS=35;
    public static final int ELSE=81;
    public static final int ASK=42;
    public static final int TYPESWITCH=222;
    public static final int WHITESPACE=54;
    public static final int LCURLY=7;
    public static final int SEMICOLON=23;
    public static final int T_FORLET=163;
    public static final int T_SQL_FROM=175;
    public static final int REWRITEVNODE1=247;
    public static final int EMPTY=212;
    public static final int NCNAME=9;
    public static final int INTERSECT=117;
    public static final int GROUP=152;
    public static final int XPATH=241;
    public static final int T_WHERE=164;
    public static final int DESCRIBE=43;
    public static final int GT=65;
    public static final int DATATYPE=140;
    public static final int T_QSTRING=249;
    public static final int T_FLWOR=160;
    public static final int LANG=138;
    public static final int T_VERSION=230;
    public static final int OPTION=218;
    public static final int T_STABLE_ORDER_BY=197;
    public static final int T_CASTAS=188;
    public static final int T_BOUNDARYSPACE_DECL=231;
    public static final int T_VERB=182;
    public static final int SATISFIES=223;
    public static final int VERSION=216;
    public static final int IDIV=114;
    public static final int DESCENDANTORSELF=92;
    public static final int ASCENDING=77;
    public static final int ATS=73;
    public static final int AT=12;
    public static final int AS=75;
    public static final int STR=137;
    public static final int PARENT=95;
    public static final int CONSTRUCTION=207;
    public static final int SLASH=18;
    public static final int THEN=80;
    public static final int DOCUMENT=133;
    public static final int COLLATION=87;
    public static final int OFFSET=69;
    public static final int T_CONSTRUCT=169;
    public static final int ANCESTOR=96;
    public static final int PLUS=29;
    public static final int QSTRING=10;
    public static final int T_SUBJECT=181;
    public static final int CASTABLE=121;
    public static final int T_GROUP_BY=198;
    public static final int INTEGER=6;
    public static final int BY=72;
    public static final int LESSTHAN=27;
    public static final int EMPTYSEQUENCE=124;
    public static final int PRECEDINGSIBLING=97;
    public static final int ENDPOINT=154;
    public static final int T_SQL_WHERE=174;
    public static final int ITEM=125;
    public static final int TO=112;
    public static final int T_TREATAS=190;
    public static final int INHERIT=209;
    public static final int PNAME_NS=45;
    public static final int HAVING=153;
    public static final int ENDELM=5;
    public static final int MINUS=30;
    public static final int TEXT=128;
    public static final int MODULE=208;
    public static final int ORDERED=100;
    public static final int UNION=116;
    public static final int T_IRI_CONSTRUCT=243;
    public static final int T_DEFAULT_COLLATION_DECL=235;
    public static final int COLON=16;
    public static final int SCHEMA=211;
    public static final int T_CASTABLEAS=189;
    public static final int DECIMAL=245;
    public static final int VALIDATE=224;
    public static final int INSTANCE=119;
    public static final int PROCESSINGINSTRUCTION=130;
    public static final int NOINHERIT=210;
    public static final int LESSTHANLCURLY=50;
    public static final int RCURLY=8;
    public static final int T_PARAM=195;
    public static final int DECLARE=102;
    public static final int T_ANON_BLANK=179;
    public static final int DIV=113;
    public static final int DESCENDING=76;
    public static final int SELF=91;
    public static final int T_UNOPTIMIZED_FUNCTION_CALL=252;
    public static final int CAST=122;
    public static final int PREFIX=108;
    public static final int EXTERNAL=204;
    public static final int LT=62;
    public static final int UNIONSYMBOL=31;
    public static final int FOLLOWINGSIBLING=93;
    public static final int ORSYMBOL=51;
    public static final int CASE=220;
    public static final int ENCODING=217;
    public static final int EQUALS=37;
    public static final int SCHEMAATTRIBUTE=131;
    public static final int LPAR=21;
    public static final int T_VAR=176;
    public static final int CARET=14;
    public static final int LANGMATCHES=139;
    public static final int BASE=109;
    public static final int T_MODULE_IMPORT=237;
    public static final int VAR=4;
    public static final int T_NAMESPACE=156;
    public static final int T_SPARQL_WHERE=166;
    public static final int COMMENT=129;
    public static final int SELECT=44;
    public static final int ISIRI=142;
    public static final int NE=61;
    public static final int GREATERTHAN=28;
    public static final int BOUNDARYSPACE=200;
    public static final int REWRITEVNODE=246;
    public static final int NODE=126;
    public static final int CDATASTART=47;
    public static final int T_ORDER=170;
    public static final int GREATEST=85;
    public static final int BLANK_NODE_LABEL=39;
    public static final int T_MAIN=184;
    public static final int EVERY=221;
    public static final int T_FUNCTION_CALL=194;
    public static final int CDATAELMEND=48;
    public static final int OF=123;
    public static final int T_VARIABLE_DECL=191;
    public static final int NAMESPACE=103;
    public static final int ISBLANK=144;
    public static final int T_BASEURI_DECL=236;
    public static final int T_PAR=185;
    public static final int COLONCOLON=38;
    public static final int T_XML_ELEMENT=157;
    public static final int VARIABLE=202;
    public static final int SLASHSLASH=26;
    public static final int T_XML_CONTENTS=251;
    public static final int NOPRESERVE=205;
    public static final int T_EXTERNAL_VARIABLE_DECL=192;
    public static final int NAMED=134;
    public static final int OR=111;
    public static final int FILTER=136;
    public static final int RCURLYGREATERTHAN=49;
    public static final int IRI_CONSTRUCT=41;
    public static final int CARETCARET=15;
    public static final int FROM=67;
    public static final int FALSE=148;
    public static final int DISTINCT=151;
    public static final int WHERE=84;
    public static final int LAX=219;
    public static final int HAFENEQUALS=36;
    public static final int ORDER=71;
    public static final int LIMIT=68;
    public static final int T_HAVING=199;
    public static final int ATTRIBUTE=90;
    public static final int FOR=66;
    public static final int DOTDOT=25;
    public static final int FOLLOWING=94;
    public static final int AND=110;
    public static final int T_XML_ATTRIBUTE=159;
    public static final int IF=79;
    public static final int ISURI=143;
    public static final int SCHEMAELEMENT=132;
    public static final int IN=74;
    public static final int COMMA=17;
    public static final int IS=59;
    public static final int SOME=225;
    public static final int QUESTIONMARK=32;
    public static final int T_BODY_PART=240;
    public static final int T_SCHEMA_IMPORT=238;
    public static final int NOTHING=250;
    public static final int T_QUERY_BODY=239;
    public static final int STRIP=201;
    public static final int RBRACKET=20;
    public static final int DOT=11;
    public static final int STABLE=78;
    public static final int T_OPTION_DECL=193;
    public static final int XQUERY=215;
    public static final int DELETEVNODE=248;
    public static final int ANDSYMBOL=52;
    public static final int DEFAULT=104;
    public static final int DESCENDANT=89;
    public static final int NCNAMEELM=56;
    public static final int T_SPARQL_FOR=165;
    public static final int T_LITERAL_CONSTRUCT=242;
    public static final int TRUE=147;
    public static final int BASEURI=107;
    public static final int UNORDERED=101;
    public static final int T_TABLE=177;
    public static final int OPTIONAL=135;
    public static final int T_TYPE=187;
    public static final int T_UNION=172;
    public static final int T_LET=168;
    public static final int T_EMPTY_ORDER_DECL=234;
    public static final int ORDERING=213;
    public static final int ASSIGN=13;
    public static final int LESSTHANLESSTHAN=33;
    public static final int DOCUMENTNODE=127;
    public static final int T_SQL_FOR=173;
    public static final int T_EMPTY_ANON_BLANK=180;
    public static final int LEAST=86;
    public static final int RPAR=22;
    public static final int T_DEFAULT_DECL=232;
    public static final int DESC=228;
    public static final int ANCESTORORSELF=99;
    public static final int LET=70;
    public static final int LE=64;
    public static final int TREAT=120;

    // delegates
    // delegators


        public XSPARQLSimplifier(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public XSPARQLSimplifier(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return XSPARQLSimplifier.tokenNames; }
    public String getGrammarFileName() { return "org/deri/xsparql/rewriter/XSPARQLSimplifier.g"; }


      private static final Logger logger = Logger.getLogger(XSPARQLSimplifier.class.getClass().getName());

      private String nodeFunction;


      /**
       * set the XQuery evaluation engine
       */
      public void setEngine(String xqueryEngine, String sparqlmethod) {
       if (xqueryEngine.equals("qexo") && sparqlmethod.equals("arq")) {
          this.nodeFunction = "_java:resultNode";
        } else {
          this.nodeFunction = "_xsparql:_resultNode";
        }
      }



    protected String format(String relation) {
      logger.info("format: "+relation);
      if (relation.matches(".*\\..*")) {
        logger.info("format-true");
        String[] split = relation.split("\\.");
        logger.info("format-true: "+split.length);
        return new String("\"\"" + split[0] +"\"\".\"\"" + split[1] +"\"\"") ;
      } else {
        logger.info("format-false");
        return relation;
      }
    }



    public static class topdown_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "topdown"
    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:207:1: topdown : ( varrewrite | singleconcat | markunoptimized );
    public final XSPARQLSimplifier.topdown_return topdown() throws RecognitionException {
        XSPARQLSimplifier.topdown_return retval = new XSPARQLSimplifier.topdown_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLSimplifier.varrewrite_return varrewrite1 = null;

        XSPARQLSimplifier.singleconcat_return singleconcat2 = null;

        XSPARQLSimplifier.markunoptimized_return markunoptimized3 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:208:3: ( varrewrite | singleconcat | markunoptimized )
            int alt1=3;
            alt1 = dfa1.predict(input);
            switch (alt1) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:208:5: varrewrite
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_varrewrite_in_topdown961);
                    varrewrite1=varrewrite();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==1 ) 
                     
                    if ( _first_0==null ) _first_0 = varrewrite1.tree;

                    if ( state.backtracking==1 ) {
                    retval.tree = (CommonTree)_first_0;
                    if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                        retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:209:5: singleconcat
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_singleconcat_in_topdown967);
                    singleconcat2=singleconcat();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==1 ) 
                     
                    if ( _first_0==null ) _first_0 = singleconcat2.tree;

                    if ( state.backtracking==1 ) {
                    retval.tree = (CommonTree)_first_0;
                    if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                        retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:210:5: markunoptimized
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_markunoptimized_in_topdown973);
                    markunoptimized3=markunoptimized();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==1 ) 
                     
                    if ( _first_0==null ) _first_0 = markunoptimized3.tree;

                    if ( state.backtracking==1 ) {
                    retval.tree = (CommonTree)_first_0;
                    if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                        retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "topdown"

    public static class varrewrite_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varrewrite"
    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:213:1: varrewrite : ( ^(r= REWRITEVNODE v= VAR ) -> ^( T_FLWOR[$v.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v.token,\"LET\"] VAR[$v.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) ) | ^( T_VAR q= QSTRING VAR ) -> QSTRING[\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"] | ^( T_VAR c= COMMA q= QSTRING VAR ) -> QSTRING[$c.text+\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"] | ^(r= REWRITEVNODE ^( T_VAR ( COMMA )? q= QSTRING v= VAR ) ) -> ^( T_FLWOR[$q.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $q.text + \" from \" + $q.line + \":\" + $q.pos] ^( T_LET[$q.token,\"LET\"] VAR[$q.token, \"\\$\" + varName] ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sqlResultNode\"] ^( T_PARAMS VAR[$r.text] QSTRING ) ) ) ) | ^(r= REWRITEVNODE LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR ) -> ^( T_FLWOR[$v2.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v2.token,\"LET\"] VAR[$v2.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) ) | ^(r= REWRITEVNODE q= NOTHING ) -> COMMENT[$q.token, \"dependent variable \" + $q.text] | DELETEVNODE -> DELETEVNODE | ^( REWRITEVNODE1 v= VAR ) -> QSTRING[$v.token, $v.text + \" \"] | ^( REWRITEVNODE1 vv= NOTHING ) -> QSTRING[$vv.token, \" \"] | ^( REWRITEVNODE1 LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR ) -> QSTRING[$n.token, \"(\" + $n.text + \"(\" + $v.text + \") AS \" + $v2.text + \")\"] );
    public final XSPARQLSimplifier.varrewrite_return varrewrite() throws RecognitionException {
        XSPARQLSimplifier.varrewrite_return retval = new XSPARQLSimplifier.varrewrite_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree r=null;
        CommonTree v=null;
        CommonTree q=null;
        CommonTree c=null;
        CommonTree n=null;
        CommonTree v2=null;
        CommonTree vv=null;
        CommonTree T_VAR4=null;
        CommonTree VAR5=null;
        CommonTree T_VAR6=null;
        CommonTree VAR7=null;
        CommonTree T_VAR8=null;
        CommonTree COMMA9=null;
        CommonTree LPAR10=null;
        CommonTree T_FUNCTION_CALL11=null;
        CommonTree T_PARAMS12=null;
        CommonTree XPATH13=null;
        CommonTree AS14=null;
        CommonTree RPAR15=null;
        CommonTree DELETEVNODE16=null;
        CommonTree REWRITEVNODE117=null;
        CommonTree REWRITEVNODE118=null;
        CommonTree REWRITEVNODE119=null;
        CommonTree LPAR20=null;
        CommonTree T_FUNCTION_CALL21=null;
        CommonTree T_PARAMS22=null;
        CommonTree XPATH23=null;
        CommonTree AS24=null;
        CommonTree RPAR25=null;

        CommonTree r_tree=null;
        CommonTree v_tree=null;
        CommonTree q_tree=null;
        CommonTree c_tree=null;
        CommonTree n_tree=null;
        CommonTree v2_tree=null;
        CommonTree vv_tree=null;
        CommonTree T_VAR4_tree=null;
        CommonTree VAR5_tree=null;
        CommonTree T_VAR6_tree=null;
        CommonTree VAR7_tree=null;
        CommonTree T_VAR8_tree=null;
        CommonTree COMMA9_tree=null;
        CommonTree LPAR10_tree=null;
        CommonTree T_FUNCTION_CALL11_tree=null;
        CommonTree T_PARAMS12_tree=null;
        CommonTree XPATH13_tree=null;
        CommonTree AS14_tree=null;
        CommonTree RPAR15_tree=null;
        CommonTree DELETEVNODE16_tree=null;
        CommonTree REWRITEVNODE117_tree=null;
        CommonTree REWRITEVNODE118_tree=null;
        CommonTree REWRITEVNODE119_tree=null;
        CommonTree LPAR20_tree=null;
        CommonTree T_FUNCTION_CALL21_tree=null;
        CommonTree T_PARAMS22_tree=null;
        CommonTree XPATH23_tree=null;
        CommonTree AS24_tree=null;
        CommonTree RPAR25_tree=null;
        RewriteRuleNodeStream stream_AS=new RewriteRuleNodeStream(adaptor,"token AS");
        RewriteRuleNodeStream stream_NCNAME=new RewriteRuleNodeStream(adaptor,"token NCNAME");
        RewriteRuleNodeStream stream_XPATH=new RewriteRuleNodeStream(adaptor,"token XPATH");
        RewriteRuleNodeStream stream_REWRITEVNODE=new RewriteRuleNodeStream(adaptor,"token REWRITEVNODE");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleNodeStream stream_DELETEVNODE=new RewriteRuleNodeStream(adaptor,"token DELETEVNODE");
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleNodeStream stream_T_VAR=new RewriteRuleNodeStream(adaptor,"token T_VAR");
        RewriteRuleNodeStream stream_NOTHING=new RewriteRuleNodeStream(adaptor,"token NOTHING");
        RewriteRuleNodeStream stream_T_PARAMS=new RewriteRuleNodeStream(adaptor,"token T_PARAMS");
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_REWRITEVNODE1=new RewriteRuleNodeStream(adaptor,"token REWRITEVNODE1");


          String varName = "";

        try {
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:217:3: ( ^(r= REWRITEVNODE v= VAR ) -> ^( T_FLWOR[$v.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v.token,\"LET\"] VAR[$v.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) ) | ^( T_VAR q= QSTRING VAR ) -> QSTRING[\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"] | ^( T_VAR c= COMMA q= QSTRING VAR ) -> QSTRING[$c.text+\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"] | ^(r= REWRITEVNODE ^( T_VAR ( COMMA )? q= QSTRING v= VAR ) ) -> ^( T_FLWOR[$q.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $q.text + \" from \" + $q.line + \":\" + $q.pos] ^( T_LET[$q.token,\"LET\"] VAR[$q.token, \"\\$\" + varName] ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sqlResultNode\"] ^( T_PARAMS VAR[$r.text] QSTRING ) ) ) ) | ^(r= REWRITEVNODE LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR ) -> ^( T_FLWOR[$v2.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v2.token,\"LET\"] VAR[$v2.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) ) | ^(r= REWRITEVNODE q= NOTHING ) -> COMMENT[$q.token, \"dependent variable \" + $q.text] | DELETEVNODE -> DELETEVNODE | ^( REWRITEVNODE1 v= VAR ) -> QSTRING[$v.token, $v.text + \" \"] | ^( REWRITEVNODE1 vv= NOTHING ) -> QSTRING[$vv.token, \" \"] | ^( REWRITEVNODE1 LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR ) -> QSTRING[$n.token, \"(\" + $n.text + \"(\" + $v.text + \") AS \" + $v2.text + \")\"] )
            int alt3=10;
            alt3 = dfa3.predict(input);
            switch (alt3) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:217:6: ^(r= REWRITEVNODE v= VAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,REWRITEVNODE,FOLLOW_REWRITEVNODE_in_varrewrite995); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_REWRITEVNODE.add(r);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = r;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite999); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }

                    if ( state.backtracking==1 ) {
                       varName=Helper.removeLeading((v!=null?v.getText():null), "$"); 
                    }


                    // AST REWRITE
                    // elements: VAR, VAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 218:3: -> ^( T_FLWOR[$v.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v.token,\"LET\"] VAR[$v.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:218:6: ^( T_FLWOR[$v.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v.token,\"LET\"] VAR[$v.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, v.token, "i'm a stupid flworExpr"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(COMMENT, "SPARQL variable " + (v!=null?v.getText():null) + " from " + (v!=null?v.getLine():0) + ":" + (v!=null?v.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:220:8: ^( T_LET[$v.token,\"LET\"] VAR[$v.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, v.token, "LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, v.token, "$" + varName));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:222:10: ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, nodeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:224:12: ^( T_PARAMS VAR[$r.text] QSTRING[varName] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, (r!=null?r.getText():null)));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, varName));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:232:5: ^( T_VAR q= QSTRING VAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    T_VAR4=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_varrewrite1174); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_VAR.add(T_VAR4);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = T_VAR4;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_varrewrite1178); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_QSTRING.add(q);

                    _last = (CommonTree)input.LT(1);
                    VAR5=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1180); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(VAR5);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 233:3: -> QSTRING[\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "+format((q!=null?q.getText():null))+" AS \"\"" + (q!=null?q.getText():null) +"\"\" "));

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:235:5: ^( T_VAR c= COMMA q= QSTRING VAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    T_VAR6=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_varrewrite1199); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_VAR.add(T_VAR6);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = T_VAR6;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_varrewrite1203); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_COMMA.add(c);

                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_varrewrite1207); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_QSTRING.add(q);

                    _last = (CommonTree)input.LT(1);
                    VAR7=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1209); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(VAR7);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 236:3: -> QSTRING[$c.text+\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (c!=null?c.getText():null)+" "+format((q!=null?q.getText():null))+" AS \"\"" + (q!=null?q.getText():null) +"\"\" "));

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:237:6: ^(r= REWRITEVNODE ^( T_VAR ( COMMA )? q= QSTRING v= VAR ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,REWRITEVNODE,FOLLOW_REWRITEVNODE_in_varrewrite1229); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_REWRITEVNODE.add(r);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = r;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    _last = (CommonTree)input.LT(1);
                    T_VAR8=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_varrewrite1232); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_VAR.add(T_VAR8);


                    if ( state.backtracking==1 )
                    if ( _first_1==null ) _first_1 = T_VAR8;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:237:31: ( COMMA )?
                    int alt2=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt2=1;
                            }
                            break;
                    }

                    switch (alt2) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: COMMA
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA9=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_varrewrite1234); if (state.failed) return retval; 
                            if ( state.backtracking==1 ) stream_COMMA.add(COMMA9);


                            if ( state.backtracking==1 ) {
                            retval.tree = (CommonTree)_first_0;
                            if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                                retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_varrewrite1239); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_QSTRING.add(q);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1243); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }

                    if ( state.backtracking==1 ) {
                       varName = Helper.removeLeading((v!=null?v.getText():null), "$"); 
                    }


                    // AST REWRITE
                    // elements: VAR, QSTRING, VAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 238:3: -> ^( T_FLWOR[$q.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $q.text + \" from \" + $q.line + \":\" + $q.pos] ^( T_LET[$q.token,\"LET\"] VAR[$q.token, \"\\$\" + varName] ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sqlResultNode\"] ^( T_PARAMS VAR[$r.text] QSTRING ) ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:238:6: ^( T_FLWOR[$q.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $q.text + \" from \" + $q.line + \":\" + $q.pos] ^( T_LET[$q.token,\"LET\"] VAR[$q.token, \"\\$\" + varName] ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sqlResultNode\"] ^( T_PARAMS VAR[$r.text] QSTRING ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, q.token, "i'm a stupid flworExpr"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(COMMENT, "SPARQL variable " + (q!=null?q.getText():null) + " from " + (q!=null?q.getLine():0) + ":" + (q!=null?q.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:240:8: ^( T_LET[$q.token,\"LET\"] VAR[$q.token, \"\\$\" + varName] ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sqlResultNode\"] ^( T_PARAMS VAR[$r.text] QSTRING ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, q.token, "LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, q.token, "$" + varName));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:242:10: ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sqlResultNode\"] ^( T_PARAMS VAR[$r.text] QSTRING ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, "_xsparql:_sqlResultNode"));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:244:12: ^( T_PARAMS VAR[$r.text] QSTRING )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, (r!=null?r.getText():null)));
                        adaptor.addChild(root_4, stream_QSTRING.nextNode());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:251:6: ^(r= REWRITEVNODE LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,REWRITEVNODE,FOLLOW_REWRITEVNODE_in_varrewrite1418); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_REWRITEVNODE.add(r);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = r;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    LPAR10=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_varrewrite1420); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_LPAR.add(LPAR10);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    _last = (CommonTree)input.LT(1);
                    T_FUNCTION_CALL11=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_varrewrite1423); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL11);


                    if ( state.backtracking==1 )
                    if ( _first_1==null ) _first_1 = T_FUNCTION_CALL11;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    n=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_varrewrite1427); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NCNAME.add(n);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_3 = _last;
                    CommonTree _first_3 = null;
                    _last = (CommonTree)input.LT(1);
                    T_PARAMS12=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_varrewrite1430); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_PARAMS.add(T_PARAMS12);


                    if ( state.backtracking==1 )
                    if ( _first_2==null ) _first_2 = T_PARAMS12;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_4 = _last;
                    CommonTree _first_4 = null;
                    _last = (CommonTree)input.LT(1);
                    XPATH13=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_varrewrite1433); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_XPATH.add(XPATH13);


                    if ( state.backtracking==1 )
                    if ( _first_3==null ) _first_3 = XPATH13;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1437); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_4;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_3;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
                    }

                    _last = (CommonTree)input.LT(1);
                    AS14=(CommonTree)match(input,AS,FOLLOW_AS_in_varrewrite1442); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_AS.add(AS14);

                    _last = (CommonTree)input.LT(1);
                    v2=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1446); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(v2);

                    _last = (CommonTree)input.LT(1);
                    RPAR15=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_varrewrite1448); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_RPAR.add(RPAR15);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }

                    if ( state.backtracking==1 ) {
                      varName=Helper.removeLeading((v2!=null?v2.getText():null), "$");
                    }


                    // AST REWRITE
                    // elements: T_PARAMS, VAR, T_FUNCTION_CALL, VAR, NCNAME
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 252:3: -> ^( T_FLWOR[$v2.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v2.token,\"LET\"] VAR[$v2.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:252:6: ^( T_FLWOR[$v2.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v2.token,\"LET\"] VAR[$v2.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, v2.token, "i'm a stupid flworExpr"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(COMMENT, "SPARQL variable " + (v!=null?v.getText():null) + " from " + (v!=null?v.getLine():0) + ":" + (v!=null?v.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:254:8: ^( T_LET[$v2.token,\"LET\"] VAR[$v2.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, v2.token, "LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, v2.token, "$" + varName));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:256:10: ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot(stream_T_FUNCTION_CALL.nextNode(), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, nodeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:258:12: ^( T_PARAMS VAR[$r.text] QSTRING[varName] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, (r!=null?r.getText():null)));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, varName));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:265:6: ^(r= REWRITEVNODE q= NOTHING )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,REWRITEVNODE,FOLLOW_REWRITEVNODE_in_varrewrite1623); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_REWRITEVNODE.add(r);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = r;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,NOTHING,FOLLOW_NOTHING_in_varrewrite1627); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NOTHING.add(q);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 266:3: -> COMMENT[$q.token, \"dependent variable \" + $q.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, q.token, "dependent variable " + (q!=null?q.getText():null)));

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:269:6: DELETEVNODE
                    {
                    _last = (CommonTree)input.LT(1);
                    DELETEVNODE16=(CommonTree)match(input,DELETEVNODE,FOLLOW_DELETEVNODE_in_varrewrite1644); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_DELETEVNODE.add(DELETEVNODE16);



                    // AST REWRITE
                    // elements: DELETEVNODE
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 270:3: -> DELETEVNODE
                    {
                        adaptor.addChild(root_0, stream_DELETEVNODE.nextNode());

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:271:5: ^( REWRITEVNODE1 v= VAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    REWRITEVNODE117=(CommonTree)match(input,REWRITEVNODE1,FOLLOW_REWRITEVNODE1_in_varrewrite1658); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_REWRITEVNODE1.add(REWRITEVNODE117);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = REWRITEVNODE117;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1662); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 272:3: -> QSTRING[$v.token, $v.text + \" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, (v!=null?v.getText():null) + " "));

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 9 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:273:5: ^( REWRITEVNODE1 vv= NOTHING )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    REWRITEVNODE118=(CommonTree)match(input,REWRITEVNODE1,FOLLOW_REWRITEVNODE1_in_varrewrite1677); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_REWRITEVNODE1.add(REWRITEVNODE118);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = REWRITEVNODE118;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    vv=(CommonTree)match(input,NOTHING,FOLLOW_NOTHING_in_varrewrite1681); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NOTHING.add(vv);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 274:3: -> QSTRING[$vv.token, \" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, vv.token, " "));

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 10 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:275:5: ^( REWRITEVNODE1 LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    REWRITEVNODE119=(CommonTree)match(input,REWRITEVNODE1,FOLLOW_REWRITEVNODE1_in_varrewrite1696); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_REWRITEVNODE1.add(REWRITEVNODE119);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = REWRITEVNODE119;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    LPAR20=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_varrewrite1698); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_LPAR.add(LPAR20);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    _last = (CommonTree)input.LT(1);
                    T_FUNCTION_CALL21=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_varrewrite1701); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL21);


                    if ( state.backtracking==1 )
                    if ( _first_1==null ) _first_1 = T_FUNCTION_CALL21;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    n=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_varrewrite1705); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NCNAME.add(n);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_3 = _last;
                    CommonTree _first_3 = null;
                    _last = (CommonTree)input.LT(1);
                    T_PARAMS22=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_varrewrite1708); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_PARAMS.add(T_PARAMS22);


                    if ( state.backtracking==1 )
                    if ( _first_2==null ) _first_2 = T_PARAMS22;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_4 = _last;
                    CommonTree _first_4 = null;
                    _last = (CommonTree)input.LT(1);
                    XPATH23=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_varrewrite1711); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_XPATH.add(XPATH23);


                    if ( state.backtracking==1 )
                    if ( _first_3==null ) _first_3 = XPATH23;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1715); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_4;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_3;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
                    }

                    _last = (CommonTree)input.LT(1);
                    AS24=(CommonTree)match(input,AS,FOLLOW_AS_in_varrewrite1720); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_AS.add(AS24);

                    _last = (CommonTree)input.LT(1);
                    v2=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varrewrite1724); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(v2);

                    _last = (CommonTree)input.LT(1);
                    RPAR25=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_varrewrite1726); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_RPAR.add(RPAR25);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 276:3: -> QSTRING[$n.token, \"(\" + $n.text + \"(\" + $v.text + \") AS \" + $v2.text + \")\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, n.token, "(" + (n!=null?n.getText():null) + "(" + (v!=null?v.getText():null) + ") AS " + (v2!=null?v2.getText():null) + ")"));

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varrewrite"

    public static class singleconcat_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleconcat"
    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:280:1: singleconcat : ^( T_FUNCTION_CALL f= NCNAME ^( T_PARAMS QSTRING ) ) -> {$f.text.equals(\"fn:concat\")}? QSTRING -> ^( T_FUNCTION_CALL $f ^( T_PARAMS QSTRING ) ) ;
    public final XSPARQLSimplifier.singleconcat_return singleconcat() throws RecognitionException {
        XSPARQLSimplifier.singleconcat_return retval = new XSPARQLSimplifier.singleconcat_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree f=null;
        CommonTree T_FUNCTION_CALL26=null;
        CommonTree T_PARAMS27=null;
        CommonTree QSTRING28=null;

        CommonTree f_tree=null;
        CommonTree T_FUNCTION_CALL26_tree=null;
        CommonTree T_PARAMS27_tree=null;
        CommonTree QSTRING28_tree=null;
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_T_PARAMS=new RewriteRuleNodeStream(adaptor,"token T_PARAMS");
        RewriteRuleNodeStream stream_NCNAME=new RewriteRuleNodeStream(adaptor,"token NCNAME");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");

        try {
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:281:3: ( ^( T_FUNCTION_CALL f= NCNAME ^( T_PARAMS QSTRING ) ) -> {$f.text.equals(\"fn:concat\")}? QSTRING -> ^( T_FUNCTION_CALL $f ^( T_PARAMS QSTRING ) ) )
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:281:5: ^( T_FUNCTION_CALL f= NCNAME ^( T_PARAMS QSTRING ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            _last = (CommonTree)input.LT(1);
            T_FUNCTION_CALL26=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_singleconcat1751); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL26);


            if ( state.backtracking==1 )
            if ( _first_0==null ) _first_0 = T_FUNCTION_CALL26;
            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            f=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_singleconcat1755); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_NCNAME.add(f);

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            _last = (CommonTree)input.LT(1);
            T_PARAMS27=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_singleconcat1758); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_T_PARAMS.add(T_PARAMS27);


            if ( state.backtracking==1 )
            if ( _first_1==null ) _first_1 = T_PARAMS27;
            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            QSTRING28=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_singleconcat1760); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_QSTRING.add(QSTRING28);


            match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
            }



            // AST REWRITE
            // elements: QSTRING, QSTRING, f, T_PARAMS, T_FUNCTION_CALL
            // token labels: f
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==1 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_f=new RewriteRuleNodeStream(adaptor,"token f",f);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 282:3: -> {$f.text.equals(\"fn:concat\")}? QSTRING
            if ((f!=null?f.getText():null).equals("fn:concat")) {
                adaptor.addChild(root_0, stream_QSTRING.nextNode());

            }
            else // 283:3: -> ^( T_FUNCTION_CALL $f ^( T_PARAMS QSTRING ) )
            {
                // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:283:6: ^( T_FUNCTION_CALL $f ^( T_PARAMS QSTRING ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_FUNCTION_CALL.nextNode(), root_1);

                adaptor.addChild(root_1, stream_f.nextNode());
                // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:283:27: ^( T_PARAMS QSTRING )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_2);

                adaptor.addChild(root_2, stream_QSTRING.nextNode());

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            input.replaceChildren(adaptor.getParent(retval.start),
                                  adaptor.getChildIndex(retval.start),
                                  adaptor.getChildIndex(_last),
                                  retval.tree);}
            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleconcat"

    public static class markunoptimized_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "markunoptimized"
    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:289:1: markunoptimized : ^(t= T_FUNCTION_CALL f= NCNAME params= . ) -> {$f.text.equals(\"fn:concat\")}? ^( T_UNOPTIMIZED_FUNCTION_CALL $f $params) -> ^( $t $f $params) ;
    public final XSPARQLSimplifier.markunoptimized_return markunoptimized() throws RecognitionException {
        XSPARQLSimplifier.markunoptimized_return retval = new XSPARQLSimplifier.markunoptimized_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree t=null;
        CommonTree f=null;
        CommonTree params=null;

        CommonTree t_tree=null;
        CommonTree f_tree=null;
        CommonTree params_tree=null;
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_NCNAME=new RewriteRuleNodeStream(adaptor,"token NCNAME");

        try {
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:290:3: ( ^(t= T_FUNCTION_CALL f= NCNAME params= . ) -> {$f.text.equals(\"fn:concat\")}? ^( T_UNOPTIMIZED_FUNCTION_CALL $f $params) -> ^( $t $f $params) )
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:290:5: ^(t= T_FUNCTION_CALL f= NCNAME params= . )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            _last = (CommonTree)input.LT(1);
            t=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_markunoptimized1809); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_T_FUNCTION_CALL.add(t);


            if ( state.backtracking==1 )
            if ( _first_0==null ) _first_0 = t;
            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            f=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_markunoptimized1813); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_NCNAME.add(f);

            _last = (CommonTree)input.LT(1);
            params=(CommonTree)input.LT(1);
            matchAny(input); if (state.failed) return retval;
             
            if ( state.backtracking==1 )
            if ( _first_1==null ) _first_1 = params;

            match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
            }



            // AST REWRITE
            // elements: f, t, params, f, params
            // token labels: f, t
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: params
            if ( state.backtracking==1 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_f=new RewriteRuleNodeStream(adaptor,"token f",f);
            RewriteRuleNodeStream stream_t=new RewriteRuleNodeStream(adaptor,"token t",t);
            RewriteRuleSubtreeStream stream_params=new RewriteRuleSubtreeStream(adaptor,"wildcard params",params);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 291:3: -> {$f.text.equals(\"fn:concat\")}? ^( T_UNOPTIMIZED_FUNCTION_CALL $f $params)
            if ((f!=null?f.getText():null).equals("fn:concat")) {
                // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:291:37: ^( T_UNOPTIMIZED_FUNCTION_CALL $f $params)
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_UNOPTIMIZED_FUNCTION_CALL, "T_UNOPTIMIZED_FUNCTION_CALL"), root_1);

                adaptor.addChild(root_1, stream_f.nextNode());
                adaptor.addChild(root_1, stream_params.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }
            else // 292:3: -> ^( $t $f $params)
            {
                // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:292:6: ^( $t $f $params)
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_t.nextNode(), root_1);

                adaptor.addChild(root_1, stream_f.nextNode());
                adaptor.addChild(root_1, stream_params.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            input.replaceChildren(adaptor.getParent(retval.start),
                                  adaptor.getChildIndex(retval.start),
                                  adaptor.getChildIndex(_last),
                                  retval.tree);}
            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "markunoptimized"

    public static class bottomup_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "bottomup"
    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:298:1: bottomup : staticconcat ;
    public final XSPARQLSimplifier.bottomup_return bottomup() throws RecognitionException {
        XSPARQLSimplifier.bottomup_return retval = new XSPARQLSimplifier.bottomup_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLSimplifier.staticconcat_return staticconcat29 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:299:3: ( staticconcat )
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:299:5: staticconcat
            {
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_staticconcat_in_bottomup1865);
            staticconcat29=staticconcat();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==1 ) 
             
            if ( _first_0==null ) _first_0 = staticconcat29.tree;

            if ( state.backtracking==1 ) {
            retval.tree = (CommonTree)_first_0;
            if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "bottomup"

    public static class staticconcat_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "staticconcat"
    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:302:1: staticconcat : ( ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )* q2= QSTRING q3= QSTRING (rest+= . )* ) ) -> ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)* QSTRING[$q2.token, $q2.text + $q3.text] ( $rest)* ) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )+ (q1= QSTRING )? ) ) -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)+ ( $q1)? ) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS VAR q1= QSTRING ) ) -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS VAR $q1) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS QSTRING ) ) -> QSTRING );
    public final XSPARQLSimplifier.staticconcat_return staticconcat() throws RecognitionException {
        XSPARQLSimplifier.staticconcat_return retval = new XSPARQLSimplifier.staticconcat_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree q2=null;
        CommonTree q3=null;
        CommonTree q1=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL30=null;
        CommonTree NCNAME31=null;
        CommonTree T_PARAMS32=null;
        CommonTree VAR33=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL34=null;
        CommonTree NCNAME35=null;
        CommonTree T_PARAMS36=null;
        CommonTree VAR37=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL38=null;
        CommonTree NCNAME39=null;
        CommonTree T_PARAMS40=null;
        CommonTree VAR41=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL42=null;
        CommonTree NCNAME43=null;
        CommonTree T_PARAMS44=null;
        CommonTree QSTRING45=null;
        CommonTree rest=null;
        List list_q=null;
        List list_rest=null;
        RuleReturnScope q = null;
        CommonTree q2_tree=null;
        CommonTree q3_tree=null;
        CommonTree q1_tree=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL30_tree=null;
        CommonTree NCNAME31_tree=null;
        CommonTree T_PARAMS32_tree=null;
        CommonTree VAR33_tree=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL34_tree=null;
        CommonTree NCNAME35_tree=null;
        CommonTree T_PARAMS36_tree=null;
        CommonTree VAR37_tree=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL38_tree=null;
        CommonTree NCNAME39_tree=null;
        CommonTree T_PARAMS40_tree=null;
        CommonTree VAR41_tree=null;
        CommonTree T_UNOPTIMIZED_FUNCTION_CALL42_tree=null;
        CommonTree NCNAME43_tree=null;
        CommonTree T_PARAMS44_tree=null;
        CommonTree QSTRING45_tree=null;
        CommonTree rest_tree=null;
        RewriteRuleNodeStream stream_T_PARAMS=new RewriteRuleNodeStream(adaptor,"token T_PARAMS");
        RewriteRuleNodeStream stream_NCNAME=new RewriteRuleNodeStream(adaptor,"token NCNAME");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_T_UNOPTIMIZED_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_UNOPTIMIZED_FUNCTION_CALL");
        RewriteRuleSubtreeStream stream_qstringandfunctioncall=new RewriteRuleSubtreeStream(adaptor,"rule qstringandfunctioncall");
        try {
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:303:3: ( ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )* q2= QSTRING q3= QSTRING (rest+= . )* ) ) -> ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)* QSTRING[$q2.token, $q2.text + $q3.text] ( $rest)* ) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )+ (q1= QSTRING )? ) ) -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)+ ( $q1)? ) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS VAR q1= QSTRING ) ) -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS VAR $q1) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS QSTRING ) ) -> QSTRING )
            int alt10=4;
            alt10 = dfa10.predict(input);
            switch (alt10) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:303:5: ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )* q2= QSTRING q3= QSTRING (rest+= . )* ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    T_UNOPTIMIZED_FUNCTION_CALL30=(CommonTree)match(input,T_UNOPTIMIZED_FUNCTION_CALL,FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat1880); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_UNOPTIMIZED_FUNCTION_CALL.add(T_UNOPTIMIZED_FUNCTION_CALL30);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = T_UNOPTIMIZED_FUNCTION_CALL30;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    NCNAME31=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_staticconcat1882); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NCNAME.add(NCNAME31);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    _last = (CommonTree)input.LT(1);
                    T_PARAMS32=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_staticconcat1885); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_PARAMS.add(T_PARAMS32);


                    if ( state.backtracking==1 )
                    if ( _first_1==null ) _first_1 = T_PARAMS32;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:303:53: ( VAR )?
                    int alt4=2;
                    switch ( input.LA(1) ) {
                        case VAR:
                            {
                            alt4=1;
                            }
                            break;
                    }

                    switch (alt4) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: VAR
                            {
                            _last = (CommonTree)input.LT(1);
                            VAR33=(CommonTree)match(input,VAR,FOLLOW_VAR_in_staticconcat1887); if (state.failed) return retval; 
                            if ( state.backtracking==1 ) stream_VAR.add(VAR33);


                            if ( state.backtracking==1 ) {
                            retval.tree = (CommonTree)_first_0;
                            if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                                retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:303:59: (q+= qstringandfunctioncall )*
                    loop5:
                    do {
                        int alt5=2;
                        switch ( input.LA(1) ) {
                        case QSTRING:
                            {
                            switch ( input.LA(2) ) {
                            case T_FUNCTION_CALL:
                                {
                                alt5=1;
                                }
                                break;

                            }

                            }
                            break;

                        }

                        switch (alt5) {
                    	case 1 :
                    	    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: q+= qstringandfunctioncall
                    	    {
                    	    _last = (CommonTree)input.LT(1);
                    	    _last = (CommonTree)input.LT(1);
                    	    pushFollow(FOLLOW_qstringandfunctioncall_in_staticconcat1892);
                    	    q=qstringandfunctioncall();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==1 ) stream_qstringandfunctioncall.add(q.getTree());
                    	    if (list_q==null) list_q=new ArrayList();
                    	    list_q.add(q.getTree());


                    	    if ( state.backtracking==1 ) {
                    	    retval.tree = (CommonTree)_first_0;
                    	    if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                    	        retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                    	    }
                    	    break;

                    	default :
                    	    break loop5;
                        }
                    } while (true);

                    _last = (CommonTree)input.LT(1);
                    q2=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_staticconcat1897); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_QSTRING.add(q2);

                    _last = (CommonTree)input.LT(1);
                    q3=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_staticconcat1901); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_QSTRING.add(q3);

                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:303:111: (rest+= . )*
                    loop6:
                    do {
                        int alt6=2;
                        switch ( input.LA(1) ) {
                        case VAR:
                        case ENDELM:
                        case INTEGER:
                        case LCURLY:
                        case RCURLY:
                        case NCNAME:
                        case QSTRING:
                        case DOT:
                        case AT:
                        case ASSIGN:
                        case CARET:
                        case CARETCARET:
                        case COLON:
                        case COMMA:
                        case SLASH:
                        case LBRACKET:
                        case RBRACKET:
                        case LPAR:
                        case RPAR:
                        case SEMICOLON:
                        case STAR:
                        case DOTDOT:
                        case SLASHSLASH:
                        case LESSTHAN:
                        case GREATERTHAN:
                        case PLUS:
                        case MINUS:
                        case UNIONSYMBOL:
                        case QUESTIONMARK:
                        case LESSTHANLESSTHAN:
                        case GREATERTHANEQUALS:
                        case LESSTHANEQUALS:
                        case HAFENEQUALS:
                        case EQUALS:
                        case COLONCOLON:
                        case BLANK_NODE_LABEL:
                        case BNODE_CONSTRUCT:
                        case IRI_CONSTRUCT:
                        case ASK:
                        case DESCRIBE:
                        case SELECT:
                        case PNAME_NS:
                        case PNAME_LN:
                        case CDATASTART:
                        case CDATAELMEND:
                        case RCURLYGREATERTHAN:
                        case LESSTHANLCURLY:
                        case ORSYMBOL:
                        case ANDSYMBOL:
                        case NOT:
                        case WHITESPACE:
                        case IRIREF:
                        case NCNAMEELM:
                        case ENDTAG:
                        case A:
                        case IS:
                        case EQ:
                        case NE:
                        case LT:
                        case GE:
                        case LE:
                        case GT:
                        case FOR:
                        case FROM:
                        case LIMIT:
                        case OFFSET:
                        case LET:
                        case ORDER:
                        case BY:
                        case ATS:
                        case IN:
                        case AS:
                        case DESCENDING:
                        case ASCENDING:
                        case STABLE:
                        case IF:
                        case THEN:
                        case ELSE:
                        case RETURN:
                        case CONSTRUCT:
                        case WHERE:
                        case GREATEST:
                        case LEAST:
                        case COLLATION:
                        case CHILD:
                        case DESCENDANT:
                        case ATTRIBUTE:
                        case SELF:
                        case DESCENDANTORSELF:
                        case FOLLOWINGSIBLING:
                        case FOLLOWING:
                        case PARENT:
                        case ANCESTOR:
                        case PRECEDINGSIBLING:
                        case PRECEDING:
                        case ANCESTORORSELF:
                        case ORDERED:
                        case UNORDERED:
                        case DECLARE:
                        case NAMESPACE:
                        case DEFAULT:
                        case ELEMENT:
                        case FUNCTION:
                        case BASEURI:
                        case PREFIX:
                        case BASE:
                        case AND:
                        case OR:
                        case TO:
                        case DIV:
                        case IDIV:
                        case MOD:
                        case UNION:
                        case INTERSECT:
                        case EXCEPT:
                        case INSTANCE:
                        case TREAT:
                        case CASTABLE:
                        case CAST:
                        case OF:
                        case EMPTYSEQUENCE:
                        case ITEM:
                        case NODE:
                        case DOCUMENTNODE:
                        case TEXT:
                        case COMMENT:
                        case PROCESSINGINSTRUCTION:
                        case SCHEMAATTRIBUTE:
                        case SCHEMAELEMENT:
                        case DOCUMENT:
                        case NAMED:
                        case OPTIONAL:
                        case FILTER:
                        case STR:
                        case LANG:
                        case LANGMATCHES:
                        case DATATYPE:
                        case BOUND:
                        case ISIRI:
                        case ISURI:
                        case ISBLANK:
                        case ISLITERAL:
                        case REGEX:
                        case TRUE:
                        case FALSE:
                        case GRAPH:
                        case GREATERTHANGREATERTHAN:
                        case DISTINCT:
                        case GROUP:
                        case HAVING:
                        case ENDPOINT:
                        case ROW:
                        case T_NAMESPACE:
                        case T_XML_ELEMENT:
                        case T_XML_CONTENT:
                        case T_XML_ATTRIBUTE:
                        case T_FLWOR:
                        case T_FUNCTION_DECL:
                        case T_PARAMS:
                        case T_FORLET:
                        case T_WHERE:
                        case T_SPARQL_FOR:
                        case T_SPARQL_WHERE:
                        case T_FOR:
                        case T_LET:
                        case T_CONSTRUCT:
                        case T_ORDER:
                        case T_RETURN:
                        case T_UNION:
                        case T_SQL_FOR:
                        case T_SQL_WHERE:
                        case T_SQL_FROM:
                        case T_VAR:
                        case T_TABLE:
                        case T_BLANK:
                        case T_ANON_BLANK:
                        case T_EMPTY_ANON_BLANK:
                        case T_SUBJECT:
                        case T_VERB:
                        case T_OBJECT:
                        case T_MAIN:
                        case T_PAR:
                        case T_INSTANCEOF:
                        case T_TYPE:
                        case T_CASTAS:
                        case T_CASTABLEAS:
                        case T_TREATAS:
                        case T_VARIABLE_DECL:
                        case T_EXTERNAL_VARIABLE_DECL:
                        case T_OPTION_DECL:
                        case T_FUNCTION_CALL:
                        case T_PARAM:
                        case T_ORDER_BY:
                        case T_STABLE_ORDER_BY:
                        case T_GROUP_BY:
                        case T_HAVING:
                        case BOUNDARYSPACE:
                        case STRIP:
                        case VARIABLE:
                        case IMPORT:
                        case EXTERNAL:
                        case NOPRESERVE:
                        case PRESERVE:
                        case CONSTRUCTION:
                        case MODULE:
                        case INHERIT:
                        case NOINHERIT:
                        case SCHEMA:
                        case EMPTY:
                        case ORDERING:
                        case COPYNAMESPACES:
                        case XQUERY:
                        case VERSION:
                        case ENCODING:
                        case OPTION:
                        case LAX:
                        case CASE:
                        case EVERY:
                        case TYPESWITCH:
                        case SATISFIES:
                        case VALIDATE:
                        case SOME:
                        case STRICT:
                        case ASC:
                        case DESC:
                        case T_MODULE_DECL:
                        case T_VERSION:
                        case T_BOUNDARYSPACE_DECL:
                        case T_DEFAULT_DECL:
                        case T_ORDER_DECL:
                        case T_EMPTY_ORDER_DECL:
                        case T_DEFAULT_COLLATION_DECL:
                        case T_BASEURI_DECL:
                        case T_MODULE_IMPORT:
                        case T_SCHEMA_IMPORT:
                        case T_QUERY_BODY:
                        case T_BODY_PART:
                        case XPATH:
                        case T_LITERAL_CONSTRUCT:
                        case T_IRI_CONSTRUCT:
                        case T_EPILOGUE:
                        case DECIMAL:
                        case REWRITEVNODE:
                        case REWRITEVNODE1:
                        case DELETEVNODE:
                        case T_QSTRING:
                        case NOTHING:
                        case T_XML_CONTENTS:
                        case T_UNOPTIMIZED_FUNCTION_CALL:
                            {
                            alt6=1;
                            }
                            break;

                        }

                        switch (alt6) {
                    	case 1 :
                    	    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: rest+= .
                    	    {
                    	    _last = (CommonTree)input.LT(1);
                    	    rest=(CommonTree)input.LT(1);
                    	    matchAny(input); if (state.failed) return retval;
                    	     
                    	    if ( state.backtracking==1 )
                    	    if ( _first_2==null ) _first_2 = rest;
                    	    if (list_rest==null) list_rest=new ArrayList();
                    	    list_rest.add(rest);


                    	    if ( state.backtracking==1 ) {
                    	    retval.tree = (CommonTree)_first_0;
                    	    if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                    	        retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                    	    }
                    	    break;

                    	default :
                    	    break loop6;
                        }
                    } while (true);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: q, rest, QSTRING, T_UNOPTIMIZED_FUNCTION_CALL, VAR, NCNAME, T_PARAMS
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: q
                    // wildcard labels: rest
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_rest=new RewriteRuleSubtreeStream(adaptor,"wildcard rest",list_rest);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_q=new RewriteRuleSubtreeStream(adaptor,"token q",list_q);
                    root_0 = (CommonTree)adaptor.nil();
                    // 304:3: -> ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)* QSTRING[$q2.token, $q2.text + $q3.text] ( $rest)* ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:304:6: ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)* QSTRING[$q2.token, $q2.text + $q3.text] ( $rest)* ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_UNOPTIMIZED_FUNCTION_CALL.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_NCNAME.nextNode());
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:304:43: ^( T_PARAMS ( VAR )? ( $q)* QSTRING[$q2.token, $q2.text + $q3.text] ( $rest)* )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:304:54: ( VAR )?
                        if ( stream_VAR.hasNext() ) {
                            adaptor.addChild(root_2, stream_VAR.nextNode());

                        }
                        stream_VAR.reset();
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:304:59: ( $q)*
                        while ( stream_q.hasNext() ) {
                            adaptor.addChild(root_2, stream_q.nextTree());

                        }
                        stream_q.reset();
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, q2.token, (q2!=null?q2.getText():null) + (q3!=null?q3.getText():null)));
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:304:103: ( $rest)*
                        while ( stream_rest.hasNext() ) {
                            adaptor.addChild(root_2, stream_rest.nextTree());

                        }
                        stream_rest.reset();

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:305:5: ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )+ (q1= QSTRING )? ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    T_UNOPTIMIZED_FUNCTION_CALL34=(CommonTree)match(input,T_UNOPTIMIZED_FUNCTION_CALL,FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat1944); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_UNOPTIMIZED_FUNCTION_CALL.add(T_UNOPTIMIZED_FUNCTION_CALL34);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = T_UNOPTIMIZED_FUNCTION_CALL34;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    NCNAME35=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_staticconcat1946); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NCNAME.add(NCNAME35);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    _last = (CommonTree)input.LT(1);
                    T_PARAMS36=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_staticconcat1949); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_PARAMS.add(T_PARAMS36);


                    if ( state.backtracking==1 )
                    if ( _first_1==null ) _first_1 = T_PARAMS36;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:305:53: ( VAR )?
                    int alt7=2;
                    switch ( input.LA(1) ) {
                        case VAR:
                            {
                            alt7=1;
                            }
                            break;
                    }

                    switch (alt7) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: VAR
                            {
                            _last = (CommonTree)input.LT(1);
                            VAR37=(CommonTree)match(input,VAR,FOLLOW_VAR_in_staticconcat1951); if (state.failed) return retval; 
                            if ( state.backtracking==1 ) stream_VAR.add(VAR37);


                            if ( state.backtracking==1 ) {
                            retval.tree = (CommonTree)_first_0;
                            if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                                retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:305:59: (q+= qstringandfunctioncall )+
                    int cnt8=0;
                    loop8:
                    do {
                        int alt8=2;
                        switch ( input.LA(1) ) {
                        case QSTRING:
                            {
                            switch ( input.LA(2) ) {
                            case T_FUNCTION_CALL:
                                {
                                alt8=1;
                                }
                                break;

                            }

                            }
                            break;

                        }

                        switch (alt8) {
                    	case 1 :
                    	    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: q+= qstringandfunctioncall
                    	    {
                    	    _last = (CommonTree)input.LT(1);
                    	    _last = (CommonTree)input.LT(1);
                    	    pushFollow(FOLLOW_qstringandfunctioncall_in_staticconcat1956);
                    	    q=qstringandfunctioncall();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==1 ) stream_qstringandfunctioncall.add(q.getTree());
                    	    if (list_q==null) list_q=new ArrayList();
                    	    list_q.add(q.getTree());


                    	    if ( state.backtracking==1 ) {
                    	    retval.tree = (CommonTree)_first_0;
                    	    if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                    	        retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                    	    }
                    	    break;

                    	default :
                    	    if ( cnt8 >= 1 ) break loop8;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(8, input);
                                throw eee;
                        }
                        cnt8++;
                    } while (true);

                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:305:87: (q1= QSTRING )?
                    int alt9=2;
                    switch ( input.LA(1) ) {
                        case QSTRING:
                            {
                            alt9=1;
                            }
                            break;
                    }

                    switch (alt9) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: q1= QSTRING
                            {
                            _last = (CommonTree)input.LT(1);
                            q1=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_staticconcat1961); if (state.failed) return retval; 
                            if ( state.backtracking==1 ) stream_QSTRING.add(q1);


                            if ( state.backtracking==1 ) {
                            retval.tree = (CommonTree)_first_0;
                            if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
                                retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
                            }
                            break;

                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: VAR, NCNAME, q1, q, T_PARAMS
                    // token labels: q1
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: q
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_q1=new RewriteRuleNodeStream(adaptor,"token q1",q1);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_q=new RewriteRuleSubtreeStream(adaptor,"token q",list_q);
                    root_0 = (CommonTree)adaptor.nil();
                    // 306:3: -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)+ ( $q1)? ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:306:6: ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)+ ( $q1)? ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, stream_NCNAME.nextNode());
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:306:31: ^( T_PARAMS ( VAR )? ( $q)+ ( $q1)? )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:306:42: ( VAR )?
                        if ( stream_VAR.hasNext() ) {
                            adaptor.addChild(root_2, stream_VAR.nextNode());

                        }
                        stream_VAR.reset();
                        if ( !(stream_q.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_q.hasNext() ) {
                            adaptor.addChild(root_2, stream_q.nextTree());

                        }
                        stream_q.reset();
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:306:51: ( $q1)?
                        if ( stream_q1.hasNext() ) {
                            adaptor.addChild(root_2, stream_q1.nextNode());

                        }
                        stream_q1.reset();

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:307:5: ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS VAR q1= QSTRING ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    T_UNOPTIMIZED_FUNCTION_CALL38=(CommonTree)match(input,T_UNOPTIMIZED_FUNCTION_CALL,FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat1997); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_UNOPTIMIZED_FUNCTION_CALL.add(T_UNOPTIMIZED_FUNCTION_CALL38);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = T_UNOPTIMIZED_FUNCTION_CALL38;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    NCNAME39=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_staticconcat1999); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NCNAME.add(NCNAME39);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    _last = (CommonTree)input.LT(1);
                    T_PARAMS40=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_staticconcat2002); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_PARAMS.add(T_PARAMS40);


                    if ( state.backtracking==1 )
                    if ( _first_1==null ) _first_1 = T_PARAMS40;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    VAR41=(CommonTree)match(input,VAR,FOLLOW_VAR_in_staticconcat2004); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_VAR.add(VAR41);

                    _last = (CommonTree)input.LT(1);
                    q1=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_staticconcat2008); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_QSTRING.add(q1);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: q1, VAR, T_PARAMS, NCNAME
                    // token labels: q1
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_q1=new RewriteRuleNodeStream(adaptor,"token q1",q1);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 308:3: -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS VAR $q1) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:308:6: ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS VAR $q1) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, stream_NCNAME.nextNode());
                        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:308:31: ^( T_PARAMS VAR $q1)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_2);

                        adaptor.addChild(root_2, stream_VAR.nextNode());
                        adaptor.addChild(root_2, stream_q1.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:309:5: ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS QSTRING ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    _last = (CommonTree)input.LT(1);
                    T_UNOPTIMIZED_FUNCTION_CALL42=(CommonTree)match(input,T_UNOPTIMIZED_FUNCTION_CALL,FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat2037); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_UNOPTIMIZED_FUNCTION_CALL.add(T_UNOPTIMIZED_FUNCTION_CALL42);


                    if ( state.backtracking==1 )
                    if ( _first_0==null ) _first_0 = T_UNOPTIMIZED_FUNCTION_CALL42;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    NCNAME43=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_staticconcat2039); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_NCNAME.add(NCNAME43);

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    _last = (CommonTree)input.LT(1);
                    T_PARAMS44=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_staticconcat2042); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_T_PARAMS.add(T_PARAMS44);


                    if ( state.backtracking==1 )
                    if ( _first_1==null ) _first_1 = T_PARAMS44;
                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    QSTRING45=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_staticconcat2044); if (state.failed) return retval; 
                    if ( state.backtracking==1 ) stream_QSTRING.add(QSTRING45);


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==1 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 310:3: -> QSTRING
                    {
                        adaptor.addChild(root_0, stream_QSTRING.nextNode());

                    }

                    retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
                    input.replaceChildren(adaptor.getParent(retval.start),
                                          adaptor.getChildIndex(retval.start),
                                          adaptor.getChildIndex(_last),
                                          retval.tree);}
                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "staticconcat"

    public static class qstringandfunctioncall_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qstringandfunctioncall"
    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:313:1: qstringandfunctioncall : QSTRING ^( T_FUNCTION_CALL (p+= . )+ ) -> QSTRING ^( T_FUNCTION_CALL ( $p)+ ) ;
    public final XSPARQLSimplifier.qstringandfunctioncall_return qstringandfunctioncall() throws RecognitionException {
        XSPARQLSimplifier.qstringandfunctioncall_return retval = new XSPARQLSimplifier.qstringandfunctioncall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QSTRING46=null;
        CommonTree T_FUNCTION_CALL47=null;
        CommonTree p=null;
        List list_p=null;

        CommonTree QSTRING46_tree=null;
        CommonTree T_FUNCTION_CALL47_tree=null;
        CommonTree p_tree=null;
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");

        try {
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:314:2: ( QSTRING ^( T_FUNCTION_CALL (p+= . )+ ) -> QSTRING ^( T_FUNCTION_CALL ( $p)+ ) )
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:314:4: QSTRING ^( T_FUNCTION_CALL (p+= . )+ )
            {
            _last = (CommonTree)input.LT(1);
            QSTRING46=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_qstringandfunctioncall2067); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_QSTRING.add(QSTRING46);

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            _last = (CommonTree)input.LT(1);
            T_FUNCTION_CALL47=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_qstringandfunctioncall2070); if (state.failed) return retval; 
            if ( state.backtracking==1 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL47);


            if ( state.backtracking==1 )
            if ( _first_0==null ) _first_0 = T_FUNCTION_CALL47;
            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:314:31: (p+= . )+
            int cnt11=0;
            loop11:
            do {
                int alt11=2;
                switch ( input.LA(1) ) {
                case VAR:
                case ENDELM:
                case INTEGER:
                case LCURLY:
                case RCURLY:
                case NCNAME:
                case QSTRING:
                case DOT:
                case AT:
                case ASSIGN:
                case CARET:
                case CARETCARET:
                case COLON:
                case COMMA:
                case SLASH:
                case LBRACKET:
                case RBRACKET:
                case LPAR:
                case RPAR:
                case SEMICOLON:
                case STAR:
                case DOTDOT:
                case SLASHSLASH:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case QUESTIONMARK:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case COLONCOLON:
                case BLANK_NODE_LABEL:
                case BNODE_CONSTRUCT:
                case IRI_CONSTRUCT:
                case ASK:
                case DESCRIBE:
                case SELECT:
                case PNAME_NS:
                case PNAME_LN:
                case CDATASTART:
                case CDATAELMEND:
                case RCURLYGREATERTHAN:
                case LESSTHANLCURLY:
                case ORSYMBOL:
                case ANDSYMBOL:
                case NOT:
                case WHITESPACE:
                case IRIREF:
                case NCNAMEELM:
                case ENDTAG:
                case A:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case FOR:
                case FROM:
                case LIMIT:
                case OFFSET:
                case LET:
                case ORDER:
                case BY:
                case ATS:
                case IN:
                case AS:
                case DESCENDING:
                case ASCENDING:
                case STABLE:
                case IF:
                case THEN:
                case ELSE:
                case RETURN:
                case CONSTRUCT:
                case WHERE:
                case GREATEST:
                case LEAST:
                case COLLATION:
                case CHILD:
                case DESCENDANT:
                case ATTRIBUTE:
                case SELF:
                case DESCENDANTORSELF:
                case FOLLOWINGSIBLING:
                case FOLLOWING:
                case PARENT:
                case ANCESTOR:
                case PRECEDINGSIBLING:
                case PRECEDING:
                case ANCESTORORSELF:
                case ORDERED:
                case UNORDERED:
                case DECLARE:
                case NAMESPACE:
                case DEFAULT:
                case ELEMENT:
                case FUNCTION:
                case BASEURI:
                case PREFIX:
                case BASE:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case INSTANCE:
                case TREAT:
                case CASTABLE:
                case CAST:
                case OF:
                case EMPTYSEQUENCE:
                case ITEM:
                case NODE:
                case DOCUMENTNODE:
                case TEXT:
                case COMMENT:
                case PROCESSINGINSTRUCTION:
                case SCHEMAATTRIBUTE:
                case SCHEMAELEMENT:
                case DOCUMENT:
                case NAMED:
                case OPTIONAL:
                case FILTER:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case GRAPH:
                case GREATERTHANGREATERTHAN:
                case DISTINCT:
                case GROUP:
                case HAVING:
                case ENDPOINT:
                case ROW:
                case T_NAMESPACE:
                case T_XML_ELEMENT:
                case T_XML_CONTENT:
                case T_XML_ATTRIBUTE:
                case T_FLWOR:
                case T_FUNCTION_DECL:
                case T_PARAMS:
                case T_FORLET:
                case T_WHERE:
                case T_SPARQL_FOR:
                case T_SPARQL_WHERE:
                case T_FOR:
                case T_LET:
                case T_CONSTRUCT:
                case T_ORDER:
                case T_RETURN:
                case T_UNION:
                case T_SQL_FOR:
                case T_SQL_WHERE:
                case T_SQL_FROM:
                case T_VAR:
                case T_TABLE:
                case T_BLANK:
                case T_ANON_BLANK:
                case T_EMPTY_ANON_BLANK:
                case T_SUBJECT:
                case T_VERB:
                case T_OBJECT:
                case T_MAIN:
                case T_PAR:
                case T_INSTANCEOF:
                case T_TYPE:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case T_VARIABLE_DECL:
                case T_EXTERNAL_VARIABLE_DECL:
                case T_OPTION_DECL:
                case T_FUNCTION_CALL:
                case T_PARAM:
                case T_ORDER_BY:
                case T_STABLE_ORDER_BY:
                case T_GROUP_BY:
                case T_HAVING:
                case BOUNDARYSPACE:
                case STRIP:
                case VARIABLE:
                case IMPORT:
                case EXTERNAL:
                case NOPRESERVE:
                case PRESERVE:
                case CONSTRUCTION:
                case MODULE:
                case INHERIT:
                case NOINHERIT:
                case SCHEMA:
                case EMPTY:
                case ORDERING:
                case COPYNAMESPACES:
                case XQUERY:
                case VERSION:
                case ENCODING:
                case OPTION:
                case LAX:
                case CASE:
                case EVERY:
                case TYPESWITCH:
                case SATISFIES:
                case VALIDATE:
                case SOME:
                case STRICT:
                case ASC:
                case DESC:
                case T_MODULE_DECL:
                case T_VERSION:
                case T_BOUNDARYSPACE_DECL:
                case T_DEFAULT_DECL:
                case T_ORDER_DECL:
                case T_EMPTY_ORDER_DECL:
                case T_DEFAULT_COLLATION_DECL:
                case T_BASEURI_DECL:
                case T_MODULE_IMPORT:
                case T_SCHEMA_IMPORT:
                case T_QUERY_BODY:
                case T_BODY_PART:
                case XPATH:
                case T_LITERAL_CONSTRUCT:
                case T_IRI_CONSTRUCT:
                case T_EPILOGUE:
                case DECIMAL:
                case REWRITEVNODE:
                case REWRITEVNODE1:
                case DELETEVNODE:
                case T_QSTRING:
                case NOTHING:
                case T_XML_CONTENTS:
                case T_UNOPTIMIZED_FUNCTION_CALL:
                    {
                    alt11=1;
                    }
                    break;

                }

                switch (alt11) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:0:0: p+= .
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    p=(CommonTree)input.LT(1);
            	    matchAny(input); if (state.failed) return retval;
            	     
            	    if ( state.backtracking==1 )
            	    if ( _first_1==null ) _first_1 = p;
            	    if (list_p==null) list_p=new ArrayList();
            	    list_p.add(p);


            	    if ( state.backtracking==1 ) {
            	    retval.tree = (CommonTree)_first_0;
            	    if ( adaptor.getParent(retval.tree)!=null && adaptor.isNil( adaptor.getParent(retval.tree) ) )
            	        retval.tree = (CommonTree)adaptor.getParent(retval.tree);}
            	    }
            	    break;

            	default :
            	    if ( cnt11 >= 1 ) break loop11;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(11, input);
                        throw eee;
                }
                cnt11++;
            } while (true);


            match(input, Token.UP, null); if (state.failed) return retval;_last = _save_last_1;
            }



            // AST REWRITE
            // elements: QSTRING, p, T_FUNCTION_CALL
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: p
            if ( state.backtracking==1 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_p=new RewriteRuleSubtreeStream(adaptor,"wildcard p",list_p);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 315:2: -> QSTRING ^( T_FUNCTION_CALL ( $p)+ )
            {
                adaptor.addChild(root_0, stream_QSTRING.nextNode());
                // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:315:13: ^( T_FUNCTION_CALL ( $p)+ )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_FUNCTION_CALL.nextNode(), root_1);

                if ( !(stream_p.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_p.hasNext() ) {
                    adaptor.addChild(root_1, stream_p.nextTree());

                }
                stream_p.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            input.replaceChildren(adaptor.getParent(retval.start),
                                  adaptor.getChildIndex(retval.start),
                                  adaptor.getChildIndex(_last),
                                  retval.tree);}
            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "qstringandfunctioncall"

    // $ANTLR start synpred2_XSPARQLSimplifier
    public final void synpred2_XSPARQLSimplifier_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:209:5: ( singleconcat )
        // org/deri/xsparql/rewriter/XSPARQLSimplifier.g:209:5: singleconcat
        {
        pushFollow(FOLLOW_singleconcat_in_synpred2_XSPARQLSimplifier967);
        singleconcat();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred2_XSPARQLSimplifier

    // Delegated rules

    public final boolean synpred2_XSPARQLSimplifier() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_XSPARQLSimplifier_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA1 dfa1 = new DFA1(this);
    protected DFA3 dfa3 = new DFA3(this);
    protected DFA10 dfa10 = new DFA10(this);
    static final String DFA1_eotS =
        "\14\uffff";
    static final String DFA1_eofS =
        "\14\uffff";
    static final String DFA1_minS =
        "\1\u00b0\1\uffff\1\2\1\11\1\4\1\2\1\uffff\1\4\2\3\1\0\1\uffff";
    static final String DFA1_maxS =
        "\1\u00f8\1\uffff\1\2\1\11\1\u00fc\1\3\1\uffff\2\u00fc\1\3\1\0\1"+
        "\uffff";
    static final String DFA1_acceptS =
        "\1\uffff\1\1\4\uffff\1\3\4\uffff\1\2";
    static final String DFA1_specialS =
        "\12\uffff\1\0\1\uffff}>";
    static final String[] DFA1_transitionS = {
            "\1\1\21\uffff\1\2\63\uffff\3\1",
            "",
            "\1\3",
            "\1\4",
            "\u009e\6\1\5\132\6",
            "\1\7\1\6",
            "",
            "\6\6\1\10\u00f2\6",
            "\1\11\u00f9\6",
            "\1\12",
            "\1\uffff",
            ""
    };

    static final short[] DFA1_eot = DFA.unpackEncodedString(DFA1_eotS);
    static final short[] DFA1_eof = DFA.unpackEncodedString(DFA1_eofS);
    static final char[] DFA1_min = DFA.unpackEncodedStringToUnsignedChars(DFA1_minS);
    static final char[] DFA1_max = DFA.unpackEncodedStringToUnsignedChars(DFA1_maxS);
    static final short[] DFA1_accept = DFA.unpackEncodedString(DFA1_acceptS);
    static final short[] DFA1_special = DFA.unpackEncodedString(DFA1_specialS);
    static final short[][] DFA1_transition;

    static {
        int numStates = DFA1_transitionS.length;
        DFA1_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA1_transition[i] = DFA.unpackEncodedString(DFA1_transitionS[i]);
        }
    }

    class DFA1 extends DFA {

        public DFA1(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 1;
            this.eot = DFA1_eot;
            this.eof = DFA1_eof;
            this.min = DFA1_min;
            this.max = DFA1_max;
            this.accept = DFA1_accept;
            this.special = DFA1_special;
            this.transition = DFA1_transition;
        }
        public String getDescription() {
            return "207:1: topdown : ( varrewrite | singleconcat | markunoptimized );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TreeNodeStream input = (TreeNodeStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA1_10 = input.LA(1);

                         
                        int index1_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_XSPARQLSimplifier()) ) {s = 11;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index1_10);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 1, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA3_eotS =
        "\21\uffff";
    static final String DFA3_eofS =
        "\21\uffff";
    static final String DFA3_minS =
        "\1\u00b0\2\2\1\uffff\1\2\1\4\1\12\1\4\11\uffff";
    static final String DFA3_maxS =
        "\1\u00f8\2\2\1\uffff\1\2\1\u00fa\1\21\1\u00fa\11\uffff";
    static final String DFA3_acceptS =
        "\3\uffff\1\7\4\uffff\1\1\1\4\1\5\1\6\1\2\1\3\1\10\1\11\1\12";
    static final String DFA3_specialS =
        "\21\uffff}>";
    static final String[] DFA3_transitionS = {
            "\1\2\105\uffff\1\1\1\4\1\3",
            "\1\5",
            "\1\6",
            "",
            "\1\7",
            "\1\10\20\uffff\1\12\u009a\uffff\1\11\111\uffff\1\13",
            "\1\14\6\uffff\1\15",
            "\1\16\20\uffff\1\20\u00e4\uffff\1\17",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA3_eot = DFA.unpackEncodedString(DFA3_eotS);
    static final short[] DFA3_eof = DFA.unpackEncodedString(DFA3_eofS);
    static final char[] DFA3_min = DFA.unpackEncodedStringToUnsignedChars(DFA3_minS);
    static final char[] DFA3_max = DFA.unpackEncodedStringToUnsignedChars(DFA3_maxS);
    static final short[] DFA3_accept = DFA.unpackEncodedString(DFA3_acceptS);
    static final short[] DFA3_special = DFA.unpackEncodedString(DFA3_specialS);
    static final short[][] DFA3_transition;

    static {
        int numStates = DFA3_transitionS.length;
        DFA3_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA3_transition[i] = DFA.unpackEncodedString(DFA3_transitionS[i]);
        }
    }

    class DFA3 extends DFA {

        public DFA3(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 3;
            this.eot = DFA3_eot;
            this.eof = DFA3_eof;
            this.min = DFA3_min;
            this.max = DFA3_max;
            this.accept = DFA3_accept;
            this.special = DFA3_special;
            this.transition = DFA3_transition;
        }
        public String getDescription() {
            return "213:1: varrewrite : ( ^(r= REWRITEVNODE v= VAR ) -> ^( T_FLWOR[$v.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v.token,\"LET\"] VAR[$v.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) ) | ^( T_VAR q= QSTRING VAR ) -> QSTRING[\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"] | ^( T_VAR c= COMMA q= QSTRING VAR ) -> QSTRING[$c.text+\" \"+format($q.text)+\" AS \\\"\\\"\" + $q.text +\"\\\"\\\" \"] | ^(r= REWRITEVNODE ^( T_VAR ( COMMA )? q= QSTRING v= VAR ) ) -> ^( T_FLWOR[$q.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $q.text + \" from \" + $q.line + \":\" + $q.pos] ^( T_LET[$q.token,\"LET\"] VAR[$q.token, \"\\$\" + varName] ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sqlResultNode\"] ^( T_PARAMS VAR[$r.text] QSTRING ) ) ) ) | ^(r= REWRITEVNODE LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR ) -> ^( T_FLWOR[$v2.token,\"i'm a stupid flworExpr\"] COMMENT[\"SPARQL variable \" + $v.text + \" from \" + $v.line + \":\" + $v.pos] ^( T_LET[$v2.token,\"LET\"] VAR[$v2.token, \"\\$\" + varName ] ^( T_FUNCTION_CALL NCNAME[nodeFunction] ^( T_PARAMS VAR[$r.text] QSTRING[varName] ) ) ) ) | ^(r= REWRITEVNODE q= NOTHING ) -> COMMENT[$q.token, \"dependent variable \" + $q.text] | DELETEVNODE -> DELETEVNODE | ^( REWRITEVNODE1 v= VAR ) -> QSTRING[$v.token, $v.text + \" \"] | ^( REWRITEVNODE1 vv= NOTHING ) -> QSTRING[$vv.token, \" \"] | ^( REWRITEVNODE1 LPAR ^( T_FUNCTION_CALL n= NCNAME ^( T_PARAMS ^( XPATH v= VAR ) ) ) AS v2= VAR RPAR ) -> QSTRING[$n.token, \"(\" + $n.text + \"(\" + $v.text + \") AS \" + $v2.text + \")\"] );";
        }
    }
    static final String DFA10_eotS =
        "\25\uffff";
    static final String DFA10_eofS =
        "\25\uffff";
    static final String DFA10_minS =
        "\1\u00fc\1\2\1\11\1\u00a2\1\2\1\4\1\12\2\3\1\uffff\1\2\2\uffff\1"+
        "\4\1\2\1\3\1\4\1\3\1\uffff\2\3";
    static final String DFA10_maxS =
        "\1\u00fc\1\2\1\11\1\u00a2\1\2\2\12\2\u00c2\1\uffff\1\2\2\uffff\2"+
        "\u00fc\1\12\1\u00fc\1\u00c2\1\uffff\2\u00fc";
    static final String DFA10_acceptS =
        "\11\uffff\1\4\1\uffff\1\1\1\3\5\uffff\1\2\2\uffff";
    static final String DFA10_specialS =
        "\25\uffff}>";
    static final String[] DFA10_transitionS = {
            "\1\1",
            "\1\2",
            "\1\3",
            "\1\4",
            "\1\5",
            "\1\6\5\uffff\1\7",
            "\1\10",
            "\1\11\6\uffff\1\13\u00b7\uffff\1\12",
            "\1\14\6\uffff\1\13\u00b7\uffff\1\12",
            "",
            "\1\15",
            "",
            "",
            "\u00f9\16",
            "\1\20\1\17\u00f9\16",
            "\1\22\6\uffff\1\21",
            "\u00f9\23",
            "\1\22\6\uffff\1\13\u00b7\uffff\1\12",
            "",
            "\1\24\u00f9\23",
            "\1\17\u00f9\16"
    };

    static final short[] DFA10_eot = DFA.unpackEncodedString(DFA10_eotS);
    static final short[] DFA10_eof = DFA.unpackEncodedString(DFA10_eofS);
    static final char[] DFA10_min = DFA.unpackEncodedStringToUnsignedChars(DFA10_minS);
    static final char[] DFA10_max = DFA.unpackEncodedStringToUnsignedChars(DFA10_maxS);
    static final short[] DFA10_accept = DFA.unpackEncodedString(DFA10_acceptS);
    static final short[] DFA10_special = DFA.unpackEncodedString(DFA10_specialS);
    static final short[][] DFA10_transition;

    static {
        int numStates = DFA10_transitionS.length;
        DFA10_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA10_transition[i] = DFA.unpackEncodedString(DFA10_transitionS[i]);
        }
    }

    class DFA10 extends DFA {

        public DFA10(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 10;
            this.eot = DFA10_eot;
            this.eof = DFA10_eof;
            this.min = DFA10_min;
            this.max = DFA10_max;
            this.accept = DFA10_accept;
            this.special = DFA10_special;
            this.transition = DFA10_transition;
        }
        public String getDescription() {
            return "302:1: staticconcat : ( ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )* q2= QSTRING q3= QSTRING (rest+= . )* ) ) -> ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)* QSTRING[$q2.token, $q2.text + $q3.text] ( $rest)* ) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? (q+= qstringandfunctioncall )+ (q1= QSTRING )? ) ) -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS ( VAR )? ( $q)+ ( $q1)? ) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS VAR q1= QSTRING ) ) -> ^( T_FUNCTION_CALL NCNAME ^( T_PARAMS VAR $q1) ) | ^( T_UNOPTIMIZED_FUNCTION_CALL NCNAME ^( T_PARAMS QSTRING ) ) -> QSTRING );";
        }
    }
 

    public static final BitSet FOLLOW_varrewrite_in_topdown961 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_singleconcat_in_topdown967 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_markunoptimized_in_topdown973 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REWRITEVNODE_in_varrewrite995 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varrewrite999 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VAR_in_varrewrite1174 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_varrewrite1178 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1180 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VAR_in_varrewrite1199 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COMMA_in_varrewrite1203 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_varrewrite1207 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1209 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_REWRITEVNODE_in_varrewrite1229 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_VAR_in_varrewrite1232 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COMMA_in_varrewrite1234 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_varrewrite1239 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1243 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_REWRITEVNODE_in_varrewrite1418 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LPAR_in_varrewrite1420 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_varrewrite1423 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_varrewrite1427 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_varrewrite1430 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_XPATH_in_varrewrite1433 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1437 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_AS_in_varrewrite1442 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1446 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_varrewrite1448 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_REWRITEVNODE_in_varrewrite1623 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NOTHING_in_varrewrite1627 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DELETEVNODE_in_varrewrite1644 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REWRITEVNODE1_in_varrewrite1658 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1662 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_REWRITEVNODE1_in_varrewrite1677 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NOTHING_in_varrewrite1681 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_REWRITEVNODE1_in_varrewrite1696 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LPAR_in_varrewrite1698 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_varrewrite1701 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_varrewrite1705 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_varrewrite1708 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_XPATH_in_varrewrite1711 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1715 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_AS_in_varrewrite1720 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_varrewrite1724 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_varrewrite1726 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_singleconcat1751 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_singleconcat1755 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_singleconcat1758 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_singleconcat1760 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_markunoptimized1809 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_markunoptimized1813 = new BitSet(new long[]{0xFFFFFFFFFFFFFFF0L,0xFFFFFFFFFFFFFFFFL,0xFFFFFFFFFFFFFFFFL,0x1FFFFFFFFFFFFFFFL});
    public static final BitSet FOLLOW_staticconcat_in_bottomup1865 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat1880 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_staticconcat1882 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_staticconcat1885 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_staticconcat1887 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_qstringandfunctioncall_in_staticconcat1892 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_staticconcat1897 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_staticconcat1901 = new BitSet(new long[]{0xFFFFFFFFFFFFFFF8L,0xFFFFFFFFFFFFFFFFL,0xFFFFFFFFFFFFFFFFL,0x1FFFFFFFFFFFFFFFL});
    public static final BitSet FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat1944 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_staticconcat1946 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_staticconcat1949 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_staticconcat1951 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_qstringandfunctioncall_in_staticconcat1956 = new BitSet(new long[]{0x0000000000000408L});
    public static final BitSet FOLLOW_QSTRING_in_staticconcat1961 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat1997 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_staticconcat1999 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_staticconcat2002 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_staticconcat2004 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_staticconcat2008 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_UNOPTIMIZED_FUNCTION_CALL_in_staticconcat2037 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_staticconcat2039 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_staticconcat2042 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_staticconcat2044 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_QSTRING_in_qstringandfunctioncall2067 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_qstringandfunctioncall2070 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_singleconcat_in_synpred2_XSPARQLSimplifier967 = new BitSet(new long[]{0x0000000000000002L});

}